declare type Validate = (data: string | number) => boolean | string | number | Date;
declare type NumberOrString = number | string;
declare type Props = {
    mode: 'onSubmit' | 'onBlur' | 'onChange';
    validationSchema?: any;
};
declare type Ref = HTMLInputElement | HTMLSelectElement | null;
export interface RegisterInput {
    ref: Ref;
    required?: boolean | string;
    min?: NumberOrString | {
        value: NumberOrString;
        message: string;
    };
    max?: NumberOrString | {
        value: NumberOrString;
        message: string;
    };
    maxLength?: number | {
        value: number;
        message: string;
    };
    minLength?: number | {
        value: number;
        message: string;
    };
    pattern?: RegExp | {
        value: RegExp;
        message: string;
    };
    validate?: Validate | {
        [key: string]: Validate;
    } | {
        value: Validate | {
            [key: string]: Validate;
        };
        message: string;
    };
}
export interface Field extends RegisterInput {
    ref: any;
    eventAttached?: Array<string>;
    watch?: boolean;
    mutationWatcher?: any;
    fields?: Array<any>;
    options?: Array<{
        ref: any;
        eventAttached?: Array<string>;
        mutationWatcher?: any;
    }>;
}
declare type Error = {
    ref: Ref;
    message: string | boolean;
    type: string;
};
export interface ErrorMessages {
    [key: string]: Error | {};
}
export default function useForm({ mode, validationSchema }?: Props): {
    register: (data: any) => (ref: any) => void;
    handleSubmit: (callback: (Object: any, e: any) => void) => (e: any) => Promise<void>;
    errors: ErrorMessages;
    watch: (filedNames?: string | string[], defaultValue?: string | string[]) => any;
};
export {};
